%ifdef TEST_H_
    global _my_strcmp
    _my_strcmp: ; int strcmp(const char *s1, const char *s2)
%else
    global strcmp
    strcmp: ; int strcmp(const char *s1, const char *s2)
%endif
    xor eax, eax ; clear the value of eax to zero
    xor ebx, ebx ; clear the value of ebx to zero

_my_strcmp_loop:
    mov al, byte [rdi] ; load the value at the memory location pointed to by `rdi` into `al`
    mov bl, byte [rsi] ; load the value at the memory location pointed to by `rsi` into 'bl'
    inc rdi ; increment the value of `rdi` by 1 to point to the next character in string 1
    inc rsi ; increment the value of `rsi` by 1 to point to the next character in string 2
    cmp al, bl ; compare the value in `al` with the value in `bl`
    jne _my_strcmp_not_equal ; if the value in `al` is not equal to 'bl', jump to `_my_strcmp_not_equal`
    cmp al, 0 ; compare the value in `al` with 0
    je _my_strcmp_equal ; if the value in `al` is equal to 0, jump to `_my_strcmp_equal`
    jmp _my_strcmp_loop ; if the values are equal, jump to `_my_strcmp_loop`

_my_strcmp_equal:
    mov eax, 0 ; set the value in `eax` to 0
    ret ; return from the function

_my_strcmp_not_equal:
    sub eax, ebx ; subtract the value in `ebx` from the value in `eax`
    ret ; return from the function

